#!/etc/opt/openit/perl -w

use strict;

my $file = "/etc/opt/openit/openit.env";

# read file
my @lines = ();
open( INPUT, "<$file" ) or die "Could not open '$file': $!\n";
$! = undef;
@lines = <INPUT>;
if( $! ) {
    die "Problems reading '$file': $!\n";
}
close( INPUT );

# do substitutions
my $PLATFORM = `/opt/openit/bin/config.guess`;
my $OPENIT_OS_ARCH="OPENIT_OS_ARCH=$PLATFORM";
my $substituted = 0;
foreach my $line( @lines ) {
    if( $line =~ m/OPENIT_OS_ARCH=rs6000/ ) {
	$line = $OPENIT_OS_ARCH;
	$substituted = 1;
	last;
    }
}
if( ! $substituted ) {
    print "No lines substituted in $file\n";
    exit( 0 );
}

# write output
my $output = "$file.tmp";
open( OUTPUT, ">$output" ) or die "Could not open '$output': $!\n";
foreach my $line( @lines ) {
    if( ! print OUTPUT $line ) {
	close( OUTPUT );
	unlink $output;
	die "Failed to write to '$output': $!\n";
    }
}
close( OUTPUT );

# rename
if( ! rename( $output, $file ) ) {
    die "Failed to rename '$output' to '$file'\n";
}
print "Substituted to '$OPENIT_OS_ARCH' in '$file'\n";

exit( 0 );
